Index: /trunk/src/pvo-utils.cc
===================================================================
--- /trunk/src/pvo-utils.cc	(revision 50)
+++ /trunk/src/pvo-utils.cc	(revision 51)
@@ -8,317 +8,341 @@
 #include <iomanip>
 
-std::string removeLeadingBlanks(std::string s)
+namespace PVO
 {
-  /**
-   * All blank spaces from the start of the string to the first non-blank-space
-   * character are deleted.
-   */ 
-  int i=0;
-  while(s[i]==' '){
-    i++;
-  }
-  std::string newstring;
-  for(unsigned int j=i;j<s.size();j++) newstring += s[j];
-  return newstring;
+  
+  void PVOError(std::string subroutine, std::string error)
+  {
+    /**
+     * Prints an ERROR message to the standard error stream, quoting
+     * the subroutine that the problem occurred in, a descriptive
+     * warning text, and sounding the bell.
+     *
+     * Format: ERROR \<function\> : Something bad happened.
+     */
+    std::string preamble = "\aERROR <" + subroutine + "> : ";
+    std::cerr << preamble;
+    for(int i=0;i<error.size();i++){
+      std::cerr << error[i];
+      if((i!=error.size()-1)&&(error[i]=='\n'))
+	std::cerr << std::setw(preamble.size()-1) <<": ";
+    }
+  }
+  //------------------------------------------------------------
+
+  std::string removeLeadingBlanks(std::string s)
+  {
+    /**
+     * All blank spaces from the start of the string to the first
+     * non-blank-space character are deleted.
+     */ 
+    int i=0;
+    while(s[i]==' '){
+      i++;
+    }
+    std::string newstring;
+    for(unsigned int j=i;j<s.size();j++) newstring += s[j];
+    return newstring;
+  }
+  //------------------------------------------------------------------------
+
+  std::string deblank(std::string s)
+  {
+    /**
+     * All blank spaces from the start of the string to the first
+     * non-blank-space character, and from the last non-blank-space
+     * character to the end are deleted.
+     */ 
+    int beg=0;
+    while(s[beg]==' '){
+      beg++;
+    }
+    int end=s.size()-1;
+    while(s[end]==' '){
+      end--;
+    }
+    std::string newstring;
+    for(int j=beg;j<=end;j++) newstring += s[j];
+    return newstring;
+  }
+  //------------------------------------------------------------------------
+
+  std::string charToBinary(char c)
+  {
+    /**
+     * A single byte, represented by a char type, is read in and converted
+     * to a binary representation.
+     *
+     * Used for debugging the single-bit writing and reading tasks.
+     *
+     * \param c A single byte, of char type.
+     * \return A std:string that shows the binary representation of that byte.
+     */
+
+    std::stringstream ss;
+    int num=c;
+    if (num<0) num+=256;
+    int factor = 128;
+    for(int i=0;i<8;i++){
+      ss << num/factor;
+      num -= num/factor * factor;
+      factor /= 2;
+    }
+    return ss.str();
+  }
+  //------------------------------------------------------------------------
+
+  std::string binaryToString(std::vector<bool> v)
+  {
+    /**
+     * A string of bits, read in as a vector of bool types, is coverted to the
+     *  equivalent string of bytes, in the form of chars (in fact, a std::string).
+     *
+     * Used for debugging the single-bit writing and reading tasks.
+     *
+     * \param v String of bits.
+     * \return Std::string of bytes (each byte a char).
+     */
+    int size = v.size();
+    int nbytes = (size-1)/8 + 1;
+    std::string output;
+    for(int byte=0;byte<nbytes;byte++){
+      int c=0;
+      for(int bit=0;bit<8;bit++){
+	int pt = byte*8+bit;
+	if(v[pt]) c += int(pow(2,7-bit));
+      }
+      //    std::cerr << int(c) << std::endl;
+      output += char(c);
+    }
+    return output;
+  }
+  //------------------------------------------------------------------------
+
+  unsigned int * binaryToInt(std::vector<bool> v)
+  {
+    /**
+     * A string of bits, read in as a vector of bool types, is coverted to a 
+     *  series of bytes, which are expressed as an array of integers (with the
+     *  decimal value of each byte).
+     *
+     * Used for debugging the single-bit writing and reading tasks.
+     *
+     * \param v String of bits.
+     * \return Sequence of integers, being the decimal value of each byte.
+     */
+    int size = v.size();
+    int nbytes = (size-1)/8 + 1;
+    unsigned int *output = new unsigned int[nbytes];
+    for(int byte=0;byte<nbytes;byte++){
+      int c=0;
+      for(int bit=0;bit<8;bit++){
+	int pt = byte*8+bit;
+	if(v[pt]) c += (unsigned int)pow(2,7-bit);
+      }
+      //    std::cerr << c << std::endl;
+      output[byte] = c;
+    }
+    return output;
+  }
+  //------------------------------------------------------------------------
+
+  double dmsToDec(std::string input)
+  {
+    /** 
+     *   Assumes the angle given is in degrees, so if passing RA as the argument,
+     *   need to multiply by 15 to get the result in degrees rather than hours.
+     *   The sign of the angle is preserved, if present.
+     */
+
+    std::string dms = removeLeadingBlanks(input);
+
+    bool isNeg = false;
+    if(dms[0]=='-') isNeg = true;
+
+    for(unsigned int i=0;i<dms.size();i++) if(dms[i]==':') dms[i]=' ';
+
+    std::stringstream ss;
+    ss.str(dms);
+
+    std::string deg,min,sec;
+    getline(ss,deg,' ');
+    getline(ss,min,' ');
+    getline(ss,sec);
+    char *end;
+    double d = strtod(deg.c_str(),&end);
+    double m = strtod(min.c_str(),&end);
+    double s = strtod(sec.c_str(),&end);  
+
+    double dec = fabs(d) + m/60. + s/3600.;
+    if(isNeg) dec = dec * -1.;
+
+    return dec;
+
+  }
+  //------------------------------------------------------------------------
+
+  std::string decToDMS(double input, int secondPrecision, std::string separator)
+  {
+    /**
+     *   This is the general form, where one can specify the degree of precision
+     *   of the seconds, and the separating character.
+     *  \param input Angle in decimal degrees.
+     *  \param secondPrecision How many decimal places to quote the seconds to.
+     *  \param separator The character (or string) to use as a separator between
+     *    hh and mm, and mm and ss.sss.
+     */ 
+    double hour = trunc(input);
+    double fraction = fabs(input - hour);
+    double min = trunc( fraction * 60. );
+    fraction = fraction * 60. - min;
+    double sec = fraction * 60.;
+  
+    int secondWidth = 2;
+    if(secondPrecision>0) secondWidth += 1 + secondPrecision;
+
+    std::stringstream output;
+    output << std::setw(2) << std::setfill('0') << std::setprecision(0)
+	   << hour << separator 
+	   << std::setw(2) << std::setfill('0') << std::setprecision(0)
+	   << min  << separator ;
+    output.setf(std::ios::fixed);
+    output << std::setw(secondWidth) << std::setfill('0') 
+	   << std::setprecision(secondPrecision) << sec;
+
+    return output.str();
+  }
+  //------------------------------------------------------------------------
+
+  std::string getIAUName(double ra, double dec)
+  {
+    /**
+     *  The positions are assumed to be J2000.0, since the name is
+     *  prefixed by a J.
+     *
+     *  \param ra RA position, in degrees.
+     *  \param dec Dec position, in degrees.
+     *  \return Name of the form J1234m4321 or J1234p0123
+     */
+
+    double raHrs = ra / 15.;
+    int h = int(raHrs);
+    int m = (int)(fmod(raHrs,1.)*60.);
+    int s = (int)(fmod(raHrs,1./60.)*3600.);
+    std::stringstream ss(std::stringstream::out);
+    ss.setf(std::ios::showpoint);
+    ss.setf(std::ios::fixed);
+    ss << "J"; 
+    ss<<std::setw(2)<<std::setfill('0')<<h;
+    ss<<std::setw(2)<<std::setfill('0')<<m;
+    ss<<std::setw(2)<<std::setfill('0')<<s;
+    int sign = int( dec / fabs(dec) );
+    double d = dec / sign;
+    h = int(d);
+    m = (int)(fmod(d,1.)*60.);
+    s = (int)(fmod(d,1./60.)*3600.);
+    if(sign==1) ss<<"p"; else ss<<"m";
+    ss<<std::setw(2)<<std::setfill('0')<<h;
+    ss.unsetf(std::ios::showpos);
+    ss<<std::setw(2)<<std::setfill('0')<<m;
+    ss<<std::setw(2)<<std::setfill('0')<<s;
+    return ss.str();
+  }
+  //------------------------------------------------------------------------
+
+  time_t my_timegm (struct tm *tm) {
+    /**
+     * Local function to get the proper GM time.
+     */
+    time_t ret;
+    char *tz;
+
+    tz = getenv("TZ");
+    setenv("TZ", "", 1);
+    tzset();
+    ret = mktime(tm);
+    if (tz) setenv("TZ", tz, 1);
+    else    unsetenv("TZ");
+    tzset();
+    return ret;
+  }
+
+  std::string addDay(std::string date)
+  {
+    /**
+     *   This assumes the format is yy/mm/dd or yymmdd or yy-mm-dd
+     *    -- the crucial thing is that the day number is in the last spot.
+     *   The format of the date is preserved, as long as it is one of those 3.
+     *  \param date Input date.
+     *  \return Date of same format as input, but one day later.
+     */ 
+
+    struct tm time;
+    time.tm_hour=0;
+    time.tm_min =0;
+    time.tm_sec =1;
+    char buf[255];
+    std::string output;
+    time_t temp;
+    if(date.size()==6) {
+      strptime(date.c_str(), "%y%m%d", &time);
+      time.tm_mday += 1;
+      temp = my_timegm(&time);
+      strftime(buf, sizeof(buf), "%y%m%d", gmtime(&temp));
+    }
+    else if(date[2]=='/'){
+      strptime(date.c_str(), "%y/%m/%d", &time);
+      time.tm_mday += 1;
+      temp = my_timegm(&time);
+      strftime(buf, sizeof(buf), "%y/%m/%d", gmtime(&temp));
+    }
+    else if(date[2]=='-'){
+      strptime(date.c_str(), "%y-%m-%d", &time);
+      time.tm_mday += 1;
+      temp = my_timegm(&time);
+      strftime(buf, sizeof(buf), "%y-%m-%d", gmtime(&temp));
+    }
+    else{
+      std::cerr << "<addDay> : date (" << date << ") has unknown format!\n";
+      return date;
+    }
+    output = buf;
+    return output;
+  
+  }
+  //------------------------------------------------------------------------
+
+  std::string makeDateObs(std::string date, std::string time)
+  {
+
+    /**
+     * This produces a string of the form YY-MM-DDThh:mm:ss.sss, using
+     * strings containing the date and the time. It is simply a matter
+     * of concatenating them, but we check the date string to make sure
+     * it has the hyphens in it.
+     *
+     * \param date A date string, assumed to be of the format YY-MM-DD,
+     * YY/MM/DD, or YYMMDD.
+     * \param time A time string, assumed to be in the format
+     * hh:mm:ss[.sss] (the fractional seconds are optional).
+     * \return A properly formatted date/time string.
+     */
+
+    std::string date_obs;
+    bool hashyphens = false;
+    for(int i=0;i<date.size();i++) 
+      hashyphens = hashyphens || (date[i]=='-') || (date[i] == '/');
+    if(hashyphens) date_obs = date;
+    else date_obs = date.substr(0,2) + "-" + 
+	   date.substr(2,2) + "-" + date.substr(4,2);
+    if(date[0]=='0') date_obs = "20" + date_obs;
+    else             date_obs = "19" + date_obs;
+    for(int i=0;i<date_obs.size();i++) 
+      if(date_obs[i]=='/') date_obs[i]='-';
+
+    date_obs += "T" + time;
+
+    return date_obs;
+
+  }
+
 }
-//------------------------------------------------------------------------
-
-std::string deblank(std::string s)
-{
-  /**
-   * All blank spaces from the start of the string to the first
-   * non-blank-space character, and from the last non-blank-space character
-   * to the end are deleted.
-   */ 
-  int beg=0;
-  while(s[beg]==' '){
-    beg++;
-  }
-  int end=s.size()-1;
-  while(s[end]==' '){
-    end--;
-  }
-  std::string newstring;
-  for(int j=beg;j<=end;j++) newstring += s[j];
-  return newstring;
-}
-//------------------------------------------------------------------------
-
-std::string charToBinary(char c)
-{
-  /**
-   * A single byte, represented by a char type, is read in and converted
-   * to a binary representation.
-   *
-   * Used for debugging the single-bit writing and reading tasks.
-   *
-   * \param c A single byte, of char type.
-   * \return A std:string that shows the binary representation of that byte.
-   */
-
-  std::stringstream ss;
-  int num=c;
-  if (num<0) num+=256;
-  int factor = 128;
-  for(int i=0;i<8;i++){
-    ss << num/factor;
-    num -= num/factor * factor;
-    factor /= 2;
-  }
-  return ss.str();
-}
-//------------------------------------------------------------------------
-
-std::string binaryToString(std::vector<bool> v)
-{
-  /**
-   * A string of bits, read in as a vector of bool types, is coverted to the
-   *  equivalent string of bytes, in the form of chars (in fact, a std::string).
-   *
-   * Used for debugging the single-bit writing and reading tasks.
-   *
-   * \param v String of bits.
-   * \return Std::string of bytes (each byte a char).
-   */
-  int size = v.size();
-  int nbytes = (size-1)/8 + 1;
-  std::string output;
-  for(int byte=0;byte<nbytes;byte++){
-    int c=0;
-    for(int bit=0;bit<8;bit++){
-      int pt = byte*8+bit;
-      if(v[pt]) c += int(pow(2,7-bit));
-    }
-    //    std::cerr << int(c) << std::endl;
-    output += char(c);
-  }
-  return output;
-}
-//------------------------------------------------------------------------
-
-unsigned int * binaryToInt(std::vector<bool> v)
-{
-  /**
-   * A string of bits, read in as a vector of bool types, is coverted to a 
-   *  series of bytes, which are expressed as an array of integers (with the
-   *  decimal value of each byte).
-   *
-   * Used for debugging the single-bit writing and reading tasks.
-   *
-   * \param v String of bits.
-   * \return Sequence of integers, being the decimal value of each byte.
-   */
-  int size = v.size();
-  int nbytes = (size-1)/8 + 1;
-  unsigned int *output = new unsigned int[nbytes];
-  for(int byte=0;byte<nbytes;byte++){
-    int c=0;
-    for(int bit=0;bit<8;bit++){
-      int pt = byte*8+bit;
-      if(v[pt]) c += (unsigned int)pow(2,7-bit);
-    }
-    //    std::cerr << c << std::endl;
-    output[byte] = c;
-  }
-  return output;
-}
-//------------------------------------------------------------------------
-
-double dmsToDec(std::string input)
-{
-  /** 
-   *   Assumes the angle given is in degrees, so if passing RA as the argument,
-   *   need to multiply by 15 to get the result in degrees rather than hours.
-   *   The sign of the angle is preserved, if present.
-   */
-
-  std::string dms = removeLeadingBlanks(input);
-
-  bool isNeg = false;
-  if(dms[0]=='-') isNeg = true;
-
-  for(unsigned int i=0;i<dms.size();i++) if(dms[i]==':') dms[i]=' ';
-
-  std::stringstream ss;
-  ss.str(dms);
-
-  std::string deg,min,sec;
-  getline(ss,deg,' ');
-  getline(ss,min,' ');
-  getline(ss,sec);
-  char *end;
-  double d = strtod(deg.c_str(),&end);
-  double m = strtod(min.c_str(),&end);
-  double s = strtod(sec.c_str(),&end);  
-
-  double dec = fabs(d) + m/60. + s/3600.;
-  if(isNeg) dec = dec * -1.;
-
-  return dec;
-
-}
-//------------------------------------------------------------------------
-
-std::string decToDMS(double input, int secondPrecision, std::string separator)
-{
-  /**
-   *   This is the general form, where one can specify the degree of precision
-   *   of the seconds, and the separating character.
-   *  \param input Angle in decimal degrees.
-   *  \param secondPrecision How many decimal places to quote the seconds to.
-   *  \param separator The character (or string) to use as a separator between
-   *    hh and mm, and mm and ss.sss.
-   */ 
-  double hour = trunc(input);
-  double fraction = fabs(input - hour);
-  double min = trunc( fraction * 60. );
-  fraction = fraction * 60. - min;
-  double sec = fraction * 60.;
-  
-  int secondWidth = 2;
-  if(secondPrecision>0) secondWidth += 1 + secondPrecision;
-
-  std::stringstream output;
-  output << std::setw(2) << std::setfill('0') << std::setprecision(0)
-	 << hour << separator 
-	 << std::setw(2) << std::setfill('0') << std::setprecision(0)
-	 << min  << separator ;
-  output.setf(std::ios::fixed);
-  output << std::setw(secondWidth) << std::setfill('0') 
-	 << std::setprecision(secondPrecision) << sec;
-
-  return output.str();
-}
-//------------------------------------------------------------------------
-
-std::string getIAUName(double ra, double dec)
-{
-  /**
-   *  The positions are assumed to be J2000.0, since the name is
-   *  prefixed by a J.
-   *
-   *  \param ra RA position, in degrees.
-   *  \param dec Dec position, in degrees.
-   *  \return Name of the form J1234m4321 or J1234p0123
-   */
-
-  double raHrs = ra / 15.;
-  int h = int(raHrs);
-  int m = (int)(fmod(raHrs,1.)*60.);
-  int s = (int)(fmod(raHrs,1./60.)*3600.);
-  std::stringstream ss(std::stringstream::out);
-  ss.setf(std::ios::showpoint);
-  ss.setf(std::ios::fixed);
-  ss << "J"; 
-  ss<<std::setw(2)<<std::setfill('0')<<h;
-  ss<<std::setw(2)<<std::setfill('0')<<m;
-  ss<<std::setw(2)<<std::setfill('0')<<s;
-  int sign = int( dec / fabs(dec) );
-  double d = dec / sign;
-  h = int(d);
-  m = (int)(fmod(d,1.)*60.);
-  s = (int)(fmod(d,1./60.)*3600.);
-  if(sign==1) ss<<"p"; else ss<<"m";
-  ss<<std::setw(2)<<std::setfill('0')<<h;
-  ss.unsetf(std::ios::showpos);
-  ss<<std::setw(2)<<std::setfill('0')<<m;
-  ss<<std::setw(2)<<std::setfill('0')<<s;
-  return ss.str();
-}
-//------------------------------------------------------------------------
-
-time_t my_timegm (struct tm *tm) {
-  /**
-   * Local function to get the proper GM time.
-   */
-  time_t ret;
-  char *tz;
-
-  tz = getenv("TZ");
-  setenv("TZ", "", 1);
-  tzset();
-  ret = mktime(tm);
-  if (tz) setenv("TZ", tz, 1);
-  else    unsetenv("TZ");
-  tzset();
-  return ret;
-}
-
-std::string addDay(std::string date)
-{
-  /**
-   *   This assumes the format is yy/mm/dd or yymmdd or yy-mm-dd
-   *    -- the crucial thing is that the day number is in the last spot.
-   *   The format of the date is preserved, as long as it is one of those 3.
-   *  \param date Input date.
-   *  \return Date of same format as input, but one day later.
-   */ 
-
-  struct tm time;
-  time.tm_hour=0;
-  time.tm_min =0;
-  time.tm_sec =1;
-  char buf[255];
-  std::string output;
-  time_t temp;
-  if(date.size()==6) {
-    strptime(date.c_str(), "%y%m%d", &time);
-    time.tm_mday += 1;
-    temp = my_timegm(&time);
-    strftime(buf, sizeof(buf), "%y%m%d", gmtime(&temp));
-  }
-  else if(date[2]=='/'){
-    strptime(date.c_str(), "%y/%m/%d", &time);
-    time.tm_mday += 1;
-    temp = my_timegm(&time);
-    strftime(buf, sizeof(buf), "%y/%m/%d", gmtime(&temp));
-  }
-  else if(date[2]=='-'){
-    strptime(date.c_str(), "%y-%m-%d", &time);
-    time.tm_mday += 1;
-    temp = my_timegm(&time);
-    strftime(buf, sizeof(buf), "%y-%m-%d", gmtime(&temp));
-  }
-  else{
-    std::cerr << "<addDay> : date (" << date << ") has unknown format!\n";
-    return date;
-  }
-  output = buf;
-  return output;
-  
-}
-//------------------------------------------------------------------------
-
-std::string makeDateObs(std::string date, std::string time)
-{
-
-  /**
-   * This produces a string of the form YY-MM-DDThh:mm:ss.sss, using
-   * strings containing the date and the time. It is simply a matter
-   * of concatenating them, but we check the date string to make sure
-   * it has the hyphens in it.
-   *
-   * \param date A date string, assumed to be of the format YY-MM-DD,
-   * YY/MM/DD, or YYMMDD.
-   * \param time A time string, assumed to be in the format
-   * hh:mm:ss[.sss] (the fractional seconds are optional).
-   * \return A properly formatted date/time string.
-   */
-
-  std::string date_obs;
-  bool hashyphens = false;
-  for(int i=0;i<date.size();i++) 
-    hashyphens = hashyphens || (date[i]=='-') || (date[i] == '/');
-  if(hashyphens) date_obs = date;
-  else date_obs = date.substr(0,2) + "-" + 
-	 date.substr(2,2) + "-" + date.substr(4,2);
-  if(date[0]=='0') date_obs = "20" + date_obs;
-  else             date_obs = "19" + date_obs;
-  for(int i=0;i<date_obs.size();i++) 
-    if(date_obs[i]=='/') date_obs[i]='-';
-
-  date_obs += "T" + time;
-
-  return date_obs;
-
-}
Index: /trunk/src/pvo-utils.hh
===================================================================
--- /trunk/src/pvo-utils.hh	(revision 50)
+++ /trunk/src/pvo-utils.hh	(revision 51)
@@ -5,46 +5,66 @@
 #include <vector>
 
-/** Return the filename of the defintion file of the PSRFITS format. */
-inline std::string getPSRFITSdefn(){ 
-  return getenv("PSRFITSDEFN"); 
+namespace PVO
+{
 
-//   std::cerr << "Using local PSRFITS definition! --> $PVO/templates/psrheader_20070209.fits\n"; 
-//   return "/DATA/SITAR_1/whi550/VO/PulsarVO/templates/psrheader_20070209.fits"; 
-};
+  static bool verbose;
+  
+  /** Report a general error, along with the offending function. */
+  void PVOError(std::string subroutine, std::string error);
+  
+  const std::string pvoconvert_help_msg = 
+"Usage: pvoconvert [options] <fits file>\n\
+  Options:\n\
+  -H  Use the PH (High Latitude) Survey settings, rather than the PM/Multibeam Survey\n\
+  -h  Display this help page.\n\
+  -v  Verbose mode for error/warning messages.\n";
 
-std::string removeLeadingBlanks(std::string s);
-///< Remove blank spaces from start of a string.
 
-std::string deblank(std::string s);
-///< Remove blank spaces from start and end of a string.  
+  /** Return the filename of the defintion file of the PSRFITS format. */
+  inline std::string getPSRFITSdefn(){ 
+    return getenv("PSRFITSDEFN"); 
+
+    //   std::cerr << "Using local PSRFITS definition! --> $PVO/templates/psrheader_20070209.fits\n"; 
+    //   return "/DATA/SITAR_1/whi550/VO/PulsarVO/templates/psrheader_20070209.fits"; 
+  };
+
+  std::string removeLeadingBlanks(std::string s);
+  ///< Remove blank spaces from start of a string.
+
+  std::string deblank(std::string s);
+  ///< Remove blank spaces from start and end of a string.  
    
-std::string charToBinary(char c);
-///< Convert a byte to binary representation.
+  std::string charToBinary(char c);
+  ///< Convert a byte to binary representation.
 
-std::string binaryToString(std::vector<bool> v);
-///< Convert a bit-wise binary representation to a set of bytes. 
+  std::string binaryToString(std::vector<bool> v);
+  ///< Convert a bit-wise binary representation to a set of bytes. 
 
-unsigned int * binaryToInt(std::vector<bool> v);
-///<Convert a series of bits into a series of bytes in decimal format.
+  unsigned int * binaryToInt(std::vector<bool> v);
+  ///<Convert a series of bits into a series of bytes in decimal format.
 
-double dmsToDec(std::string input);   
-///< Converts a string in the format +12:23:34.45 to a decimal angle in degrees.
+  double dmsToDec(std::string input);   
+  ///< Converts a string in the format +12:23:34.45 to a decimal angle
+  ///in degrees.
 
-std::string decToDMS(double input, int secondPrecision, std::string separator);
-///< Converts a decimal into a dd:mm:ss.ss format.
+  std::string decToDMS(double input, int secondPrecision, 
+		       std::string separator);
+  ///< Converts a decimal into a dd:mm:ss.ss format.
 
-/** Particular instance of decToDMS(double,int,std::string) with
-    standard precision & separator */
-inline std::string decToDMS(double input){ return decToDMS(input,2,":"); };
+  /** Particular instance of decToDMS(double,int,std::string) with
+      standard precision & separator */
+  inline std::string decToDMS(double input){ return decToDMS(input,2,":"); };
 
-std::string getIAUName(double ra, double dec);  
-///< Create an IAU-style formatted name, based on the equatorial position.
+  std::string getIAUName(double ra, double dec);  
+  ///< Create an IAU-style formatted name, based on the equatorial position.
 
-std::string addDay(std::string date);
-///< A function to add a day onto the date.
+  std::string addDay(std::string date);
+  ///< A function to add a day onto the date.
 
-/** Makes the DATE-OBS header keyword in the format mandated by the
-    FITS standard. */
-std::string makeDateObs(std::string date, std::string time);
+  /** Makes the DATE-OBS header keyword in the format mandated by the
+      FITS standard. */
+  std::string makeDateObs(std::string date, std::string time);
+
+}
 
 #endif /*UTILS_HH_*/
Index: /trunk/src/pvoconvert.cc
===================================================================
--- /trunk/src/pvoconvert.cc	(revision 50)
+++ /trunk/src/pvoconvert.cc	(revision 51)
@@ -4,4 +4,5 @@
 #include <iomanip>
 #include <string>
+#include <unistd.h>
 #include "pvo-block.hh"
 #include "pvo-header.hh"
@@ -9,41 +10,39 @@
 #include "pvo-utils.hh"
 
-using namespace Header;
-using namespace Block;
-using namespace FITS;
+using namespace PVO;
+using namespace PVO::Header;
+using namespace PVO::Block;
+using namespace PVO::FITS;
 using std::string;
 
 int main(int argc, char * argv[])
 {
+  PSRFits fitsfile;
+  fitsfile.setVerbosity(false);
   std::string fname;
   bool usingHighLatitude = false;
-  if(argc==2){
-    fname = argv[1];
-    if(fname=="-h") {
-      std::cerr << "Usage: \"pvoconvert filename\"\n"
-		<< "   or: \"pvoconvert -ph filename\" to set PH survey.\n"
-		<< "   or: \"pvoconvert -h \" to see this message.\n";
-      return 0;
+
+  char c;
+  int optCount=0;
+  while( ( c = getopt(argc,argv,"H:v:h") )!=-1){
+    optCount++;
+    switch(c) {
+    case 'v':
+      fitsfile.setVerbosity(true);
+      fname = optarg;
+      break;
+    case 'H':
+      usingHighLatitude = true;
+      fname = optarg;
+      break;
+    case 'h':
+    default:
+      std::cout << PVO::pvoconvert_help_msg;
+      return 1;
+      break;
     }
   }
-  else if(argc==3){
-    std::string opt = argv[1];
-    fname = argv[2];
-    if(opt == "-ph") {
-      usingHighLatitude = true;
-    }
-    else {
-      std::cerr << "Usage: \"pvoconvert.x filename\"\n"
-		<< "   or: \"pvoconvert.x -ph filename\" to set PH survey.\n"
-		<< "   or: \"pvoconvert.x -h \" to see this message.\n";
-      return 1;
-    }
-  }
-  else{
-    std::cerr << "Usage: \"pvoconvert.x filename\"...\n"
-	      << "   or: \"pvoconvert.x -ph filename\" to set PH survey.\n"
-	      << "   or: \"pvoconvert.x -h \" to see this message.\n";
-    return 1;
-  }
+
+  if(optCount==0) fname = argv[1];
 
   SURVEY currentSurvey = idSurvey(fname);
@@ -81,5 +80,4 @@
   bool oldMoveFlag;
 
-  PSRFits fitsfile;
   fitsfile.setOldFilename(fname);
   fitsfile.setCommandLine(argc,argv);
Index: /trunk/src/pvosummary.cc
===================================================================
--- /trunk/src/pvosummary.cc	(revision 50)
+++ /trunk/src/pvosummary.cc	(revision 51)
@@ -4,4 +4,5 @@
 #include <iomanip>
 #include <string>
+#include <glob.h>
 #include "pvo-block.hh"
 #include "pvo-header.hh"
@@ -9,7 +10,8 @@
 #include "pvo-utils.hh"
 
-using namespace Header;
-using namespace Block;
-using namespace FITS;
+using namespace PVO;
+using namespace PVO::Header;
+using namespace PVO::Block;
+using namespace PVO::FITS;
 using std::string;
 
@@ -17,30 +19,62 @@
 {
 
-  std::string name;
-  if(argc!=2){
+  bool verboseflag = false;
+
+  std::vector<std::string> namelist;
+  int i;
+  switch(argc){
+  case 1:
+    glob_t globbuf1,globbuf2;
+    globbuf1.gl_offs = 0;
+    globbuf2.gl_offs = 0;
+    glob("*.fits", GLOB_DOOFFS, NULL, &globbuf1);
+    glob("*.rf", GLOB_DOOFFS, NULL, &globbuf2);
+    namelist.resize(globbuf1.gl_pathc+globbuf2.gl_pathc);
+    for(i=0;i<globbuf1.gl_pathc+globbuf1.gl_offs;i++) 
+      namelist[i] = globbuf1.gl_pathv[i];
+    for(i=0;i<globbuf2.gl_pathc+globbuf2.gl_offs;i++) 
+      namelist[globbuf1.gl_pathc+i] = globbuf2.gl_pathv[i];
+    break;
+  case 2:
+    if(strcmp(argv[1],"-h")==0){
+      std::cout << "Usage:\n"
+		<< "  1. pvosummary [FILE]\n"
+		<< "  2. pvosummary\n---------\n"
+		<< "  1. Prints RA, DEC, DATE-OBS for single FITS file.\n"
+		<< "  2. Prints RA, DEC, DATE-OBS for all fits files in the current directory.\n"
+		<< " Note that if a keyword is not present, --- is printed.\n";
+      return 0;
+    }
+    namelist.resize(1);
+    namelist[0] = argv[1];
+    break;
+  default:
     std::cerr << " Usage : \"pvosummary filename\"\n";
     return 0;
+    break;
   }
 
-  name = argv[1];
+  for(i=0;i<namelist.size();i++){
 
-  PSRFits fitsfile;
-//   fitsfile.setVerbosity(false);
-  int status = fitsfile.openFile(name);
+    PSRFits fitsfile;
+    fitsfile.setVerbosity(verboseflag);
+    int status = fitsfile.openFile(namelist[i]);
   
-  if(status==0){
-    fitsfile.gotoPHU();
+    if(status==0){
+      fitsfile.gotoPHU();
     
-    std::string ra,dec,date;
-//     std::string missing = "N/A";
-    std::string missing = "---";
-    if(fitsfile.getKeyword<std::string>("RA",ra)!=0) ra = missing;
-    if(fitsfile.getKeyword<std::string>("DEC",dec)!=0) dec = missing;
-    if(fitsfile.getKeyword<std::string>("DATE-OBS",date)!=0) date = missing;
+      std::string ra,dec,date;
+      //     std::string missing = "N/A";
+      std::string missing = "---";
+      if(fitsfile.getKeyword<std::string>("RA",ra)!=0) ra = missing;
+      if(fitsfile.getKeyword<std::string>("DEC",dec)!=0) dec = missing;
+      if(fitsfile.getKeyword<std::string>("DATE-OBS",date)!=0) date = missing;
     
-    std::cout << name << ": \t"
-	      << std::setw(14) << ra   << " "
-	      << std::setw(14) << dec  << " "
-	      << std::setw(20) << date << "\n";
+      std::cout << namelist[i] << ": \t"
+		<< std::setw(14) << ra   << " "
+		<< std::setw(14) << dec  << " "
+		<< std::setw(20) << date << "\n";
+    }
   }
+
 }
